#ifndef cac2obj_H
#define cac2obj_H

// TODO: Remove for Mac/Linux
#define WINDOWS
#include "ac_plugin.h"

#include <stdio.h>

//---------------------------------------------------------------------------------------
class CVertSortItem
{
public:
   unsigned int mOrder;
   Vertex *mV;
   CVertSortItem()
   {
      int mOrder = 0;
      mV = NULL;
   }
};
//---------------------------------------------------------------------------------------
class CMatItem
{
public:
   char *mMatName;
   ACEntity *mEntity;
   CMatItem()
   {
      mMatName = NULL;
      mEntity = NULL;
   }
   ~CMatItem()
   {
      if( mMatName != NULL )
      {
         delete [] mMatName;
      }
      mEntity = NULL;
   }
};
//---------------------------------------------------------------------------------------
class CAc2Obj
{

private:

   // Save file
   FILE *mF;
   // Save material file
   FILE *mFMat;

   // Vertex array
   Vertex **mV;
   // Vertex array, sorted by vertex and containing numeric "original" order
   CVertSortItem *mVSorted;
   // num vertices
   unsigned int mVCount;

   // Materials
   CMatItem *mMatList;
   unsigned int mMatListCount;

   // Vertex validation/maintenance
   static int VVertfind( CVertSortItem *vlist, int count, Vertex *v );
   static void VVertsort( CVertSortItem *vlist, int left, int right );
   static void VValidate( CVertSortItem *vsorted, ACObject *o, unsigned int &numFound, bool &hasOrphans );
   static void VCollectMats( ACObject *o, CMatItem *matlist, unsigned int matlistcount );

   // Write face data to mF
   void WriteFaceData( ACObject *o, unsigned int &lastmat, bool &lastsmooth );

public:

   CAc2Obj();
   ~CAc2Obj();

   // Clear data
   void ClearVerts();
   void ClearFiles();

   // Populate vertex arrays
   // Return stats on number of vertices found
   void IdentifyAcVertices( unsigned int &numFound, bool &hasOrphans );

   // Save OBJ file
   void SaveToObjFile( char *fname, char *mname, bool vertsonly );

};
//---------------------------------------------------------------------------------------

#endif
