#include "cpmt.h"

// Static/singleton inits
bool CPmt::mInstanceInd = false;
CPmt *CPmt::mSingle = NULL;

//---------------------------------------------------------------------------------------
CPmt *CPmt::GetSingleton()
{
   if( !mInstanceInd ) {
      mSingle = new CPmt();
      mInstanceInd = true;
   }
   return mSingle;
}
//---------------------------------------------------------------------------------------
CPmt::CPmt()
{
   mInstanceInd = false;
   mV = NULL;
   mVCount = 0;
}
//---------------------------------------------------------------------------------------
CPmt::~CPmt()
{
   Clear();
}
//---------------------------------------------------------------------------------------
void CPmt::Clear()
{
   if( mV != NULL )
   {
      delete [] mV;
      mV = NULL;
   }
   mVCount = 0;
}
//---------------------------------------------------------------------------------------
void CPmt::AllocateVerts( unsigned int numverts )
{
   Clear();
   if( numverts > 0 )
   {
      mV = new Vertex*[numverts];
      mVCount = numverts;
   }
}
//---------------------------------------------------------------------------------------
